*
*   OBS.: Este modelo esta de acordo com o formato especificado no Manual de Orientacao 
*         para Usuarios de Equipamentos de Processamento Eletronico de Dados.
*         Atualizado de acordo com Guia Pratico do Convenio ICMS 57/95, 
*         atualizado at o convenio ICMS 39/00.
*        
*   ATENCAO: Verifique e ajuste TODOS os itens abaixo, ate encontrar a linha 
*            identificada como : ***** INICIO PROCESSO ****
*

******************* VARIAVEIS PARA TRANSACOES DE VENDA DE MERCADORIA ******************

   * cSaida indica onde sera gerado o arquivo final.
cSaida = 'c:\FISCAL.TXT'

   * cSeries deve conter quais as series de venda que serao exportadas por esse formato.
   * Obs.: Apos cada serie informada, SEMPRE informar o traco "-", conforme o exemplo.
   *       Aqui nao deve ser informada a serie CF (cupons fiscais). Essa  automatica.
cSeries = 'SF-'

   * cCGC deve conter o numero do CGC do emissor dos documentos fiscais
cCGC = padr('84431733000251', 14)

   * cInscricao deve conter o numero da Inscricao Estadual do emissor dos documentos fiscais
cInscricao = padr('254286356     ', 14)

   * cRazao deve conter a Razao Social do emissor dos documentos fiscais
cRazao = padr('Foto Loss Ltda. - Filial 01        ', 35)

   * cMunicipio deve conter a municipio onde se localiza o emissor dos documentos fiscais
cMunicipio = padr('Jaragua do Sul                ', 30)

   * cEstado deve conter a sigla do estado do emissor dos documentos fiscais
cEstado = 'SC'

   * cFAX deve conter o numero do FAX do emissor dos documentos fiscais
cFAX = padr('0472753555', 10)

   * cEndereco deve conter o endereco completo do emissor dos documentos fiscais
cEndereco = padr('Av. Getulio Vargas                ', 34)

   * cNumero deve conter o numero
cNumero = padr('00268', 5)

   * cComplemento deve conter o complemento
cComplemento = padr('sala 226              ', 22)

   * cBairro deve conter o bairro
cBairro = padr('Centro         ', 15)

   * cCEP (8 posicoes) deve conter o Logradouro+CEP do emissor dos documentos fiscais
cCEP = padr('89251000', 8)

   * cContato deve conter o nome de uma pessoa para contato do emissor dos documentos fiscais
cContato = padr('Eduardo Luiz Gomes          ', 28)

   * cTelefone deve conter o telefone para contato no emissor dos documentos fiscais,
   * Este campo  numrico e no pode conter espaos em branco, insira zeros no inicio 
   * para completar o campo.
cTelefone = padr('000472753555', 12)

   * cModelo deve conter, de acordo com a tabela de modelos de documentos fiscais,
   * o codigo do modelo de acordo com as series que utiliza para este formato, para 
   * definir quais os possiveis codigos de modelo da nota fiscal de venda
cModelo = padr('01', 2)

   * cSerie deve conter a serie padrao de venda para a geracao desse arquivo
cSerie = padr('001', 3)

   * cSubSerie deve conter a subserie padrao de venda para a geracao desse arquivo
cSubSerie = padr('  ', 2)


******************* VARIAVEIS PARA TRANSACOES DE VENDA DE MERCADORIA ******************

   * cCmpSeries deve conter quais as series de compra que serao exportadas por esse formato.
   * Obs.: Apos cada serie informada, SEMPRE informar o traco "-", conforme o exemplo.
cCmpSeries = 'UN-'

   * cCmpModelo deve conter, de acordo com a tabela de modelos de documentos fiscais, o 
   * codigo do modelo das notas de compra
cCmpModelo = padr('01', 2)

   * cCmpSerie deve conter a serie padrao de compra para a geracao desse arquivo
cCmpSerie = padr('  ', 2)

   * ccmpSubSerie deve conter a subserie padrao de compra para a geracao desse arquivo
cCmpSubSerie = padr('  ', 2)

***************************** INICIO PROCESSO *********************************************

dInicio = date()
dFinal  = date()
DO FORM EXTERNOS\periodo.SCX
wait 'Gerando estruturas para exportao fiscal...' window nowait


***
***                      Somente estruturas de controle para vendas
***---------------------------------------------------------------------------------------
   && Precisa deste indice pois nao tem indice que me de condicoes de buscar numero de
   && documento, data, etc, sem informar algum dado que pode variar de venda para venda.
select MOVTOS
index on NUMDOC + dtos(DATMOV) to _TMPEXP
go top

declare aTotais[10]
aTotais = 0

select ESTADO, PERICM from TABELAS ;
  into array aIcms

   && Pega somente as que forem especificamente de vendas
select VENDAS.NUMNOT, ;
		sum(val(str(iif(MOVTOS.QTDMOV > 0, MOVTOS.VLRVEN * (abs(VENDAS.VLRLIQ) - VENDAS.RETIDO - VENDAS.SUBSTT) / abs(VENDAS.VLRNOT), 0) * 100, 18, 2))) / 100 as VLRLIQ1, ;
		sum(val(str(iif(MOVTOS.QTDMOV > 0, MOVTOS.VLRMOV * MOVTOS.QTDMOV, 0) * 100, 18, 2))) / 100 as VLRNOT1, ;
		sum(val(str(iif(MOVTOS.QTDMOV < 0, MOVTOS.VLRVEN * (abs(VENDAS.VLRLIQ) - VENDAS.RETIDO - VENDAS.SUBSTT) / abs(VENDAS.VLRNOT), 0) * 100, 18, 2))) / 100 as VLRLIQ2, ;
		sum(val(str(iif(MOVTOS.QTDMOV < 0, MOVTOS.VLRMOV * MOVTOS.QTDMOV, 0) * 100, 18, 2))) / 100 as VLRNOT2 ;
   from VENDAS, MOVTOS ;
  where VENDAS.DATOPE between dInicio .and. dFinal .and. ;
        MOVTOS.NUMDOC+dtos(MOVTOS.DATMOV) = VENDAS.NUMNOT + dtos(VENDAS.DATOPE) .and. ;
		iif(VENDAS.FLGEST = 'C', MOVTOS.TIPMOV = '7', .t.) .and. ;
        (left(VENDAS.NUMNOT, 2) + '-') $ cSeries .and. ;
        VENDAS.TIPNOT = 'A' ;
  order by VENDAS.NUMNOT ;        
  group by VENDAS.NUMNOT ;        
   into cursor _Total0

   && Pega somente as que forem vendas com troca, especificamente dos produtos vendidos
select VENDAS.NUMNOT, VENDAS.UFLOJA, ;
		iif(VENDAS.FLGEST = 'C', 'S', 'N') as FLGEST, ;
		val(str(_Total0.VLRLIQ1 * 100, 18, 2)) / 100 as VLRLIQ, ;
		val(str(_Total0.VLRNOT1 * 100, 18, 2)) / 100 as VLRNOT, ;
		CLIENTE.CODCLI, ;
		VENDAS.RETIDO, ;
		iif(empty(PRODUTO.REFBAS), padr('pd' + alltrim(PRODUTO.CODMAT) + PRODUTO.DIGMAT, 12), PRODUTO.REFBAS) as REFBAS, ;
		VENDAS.SUBSTT, ;
		MOVTOS.CODMAT, ;
		MOVTOS.CODCOR, ;
		MOVTOS.CODTAM, ;
		MOVTOS.REDITE, ;
		MOVTOS.ICMITE, ;
		MOVTOS.IPIITE, ;
		MOVTOS.ICMTIP as TIPICM, ;
		MOVTOS.SERPRO as SERMAT, ;
		val(str(MOVTOS.QTDMOV * 100, 10, 2)) / 100 as QTDMOV, ;
		val(str(MOVTOS.VLRVEN * _Total0.VLRLIQ1 / _Total0.VLRNOT1 * 100, 18, 2)) / 100 as VLRVEN, ;
		padr(LeCidade(CLIENTE.CODCEP, 2, .t., .t.),2) as SIGEST, ;
		val(str(iif( VENDAS.UFLOJA='S' .or. vendas.FlgTip=1, 0,;
			aIcms[1 + ascan(aIcms, padr(LeCidade(CLIENTE.CODCEP, 2, .t., .t.),2))]), 5, 2)) as ICMCLI;
   from _Total0, VENDAS, CLIENTE, MOVTOS, PRODUTO ;
  where VENDAS.NUMNOT = _Total0.NUMNOT .and. ;
		CLIENTE.CODCLI = VENDAS.CODCLI .and. ;
        MOVTOS.NUMDOC+dtos(MOVTOS.DATMOV) = VENDAS.NUMNOT + dtos(VENDAS.DATOPE) .and. ;
        PRODUTO.CODMAT = MOVTOS.CODMAT .and. ;
		MOVTOS.QTDMOV > 0 .and. ;
		iif(VENDAS.FLGEST = 'C', MOVTOS.TIPMOV = '7', .t.) ;
  order by VENDAS.NUMNOT ;        
   into cursor _Total1

   && Pega somente as que forem vendas com troca, especificamente dos produtos trocados
select VENDAS.NUMNOT, VENDAS.UFLOJA, ;
		iif(VENDAS.FLGEST = 'C', 'S', 'N') as FLGEST, ;
		val(str(_Total0.VLRLIQ2 * -100, 18, 2)) / 100 as VLRLIQ, ;
		val(str(_Total0.VLRNOT2 * -100, 18, 2)) / 100 as VLRNOT, ;
		CLIENTE.CODCLI, ;
		VENDAS.RETIDO, ;
		iif(empty(PRODUTO.REFBAS), padr('pd' + alltrim(PRODUTO.CODMAT) + PRODUTO.DIGMAT, 12), PRODUTO.REFBAS) as REFBAS, ;
		VENDAS.SUBSTT, ;
		MOVTOS.CODMAT, ;
		MOVTOS.CODCOR, ;
		MOVTOS.CODTAM, ;
		MOVTOS.REDITE, ;
		MOVTOS.ICMITE, ;
		MOVTOS.IPIITE, ;
		MOVTOS.ICMTIP as TIPICM, ;
		MOVTOS.SERPRO as SERMAT, ;
		val(str(MOVTOS.QTDMOV * -100, 10, 2)) / 100 as QTDMOV, ;
		val(str(MOVTOS.VLRVEN * _Total0.VLRLIQ2 / _Total0.VLRNOT2 * -100, 18, 2)) / 100 as VLRVEN, ;
		padr(LeCidade(CLIENTE.CODCEP, 2, .t., .t.),2) as SIGEST, ;
		val(str(iif( VENDAS.UFLOJA='S' .or. vendas.FlgTip=1, 0,;
			aIcms[1 + ascan(aIcms, LeCidade(CLIENTE.CODCEP, 2, .t., .t.))]), 5, 2)) as ICMCLI;
   from _Total0, VENDAS, CLIENTE, MOVTOS, PRODUTO ;
  where VENDAS.NUMNOT = _Total0.NUMNOT .and. ;
		CLIENTE.CODCLI = VENDAS.CODCLI .and. ;
        MOVTOS.NUMDOC+dtos(MOVTOS.DATMOV) = VENDAS.NUMNOT + dtos(VENDAS.DATOPE) .and. ;
        PRODUTO.CODMAT = MOVTOS.CODMAT .and. ;
		MOVTOS.QTDMOV < 0 .and. ;
		iif(VENDAS.FLGEST = 'C', MOVTOS.TIPMOV = '7', .t.) ;
  order by VENDAS.NUMNOT ;        
   into cursor _Total2

   && Pega somente as que forem somente de vendas
select VENDAS.NUMNOT, VENDAS.UFLOJA, ;
		iif(VENDAS.FLGEST = 'C', 'S', 'N') as FLGEST, ;
		val(str((abs(VENDAS.VLRLIQ) - VENDAS.RETIDO - VENDAS.SUBSTT) * 100, 18, 2)) / 100 as VLRLIQ, ;
		val(str(abs(VENDAS.VLRNOT) * 100, 18, 2)) / 100 as VLRNOT, ;
		CLIENTE.CODCLI, ;
		VENDAS.RETIDO, ;
		iif(empty(PRODUTO.REFBAS), padr('pd' + alltrim(PRODUTO.CODMAT) + PRODUTO.DIGMAT, 12), PRODUTO.REFBAS) as REFBAS, ;
		VENDAS.SUBSTT, ;
		MOVTOS.CODMAT, ;
		MOVTOS.CODCOR, ;
		MOVTOS.CODTAM, ;
		MOVTOS.REDITE, ;
		MOVTOS.ICMITE, ;
		MOVTOS.IPIITE, ;
		MOVTOS.ICMTIP as TIPICM, ;
		MOVTOS.SERPRO as SERMAT, ;
		val(str(MOVTOS.QTDMOV * 100, 10, 2)) / 100 as QTDMOV, ;
		val(str(MOVTOS.VLRVEN * (abs(VENDAS.VLRLIQ) - VENDAS.RETIDO - VENDAS.SUBSTT) / abs(VENDAS.VLRNOT) * 100, 18, 2)) / 100 as VLRVEN, ;
		padr(LeCidade(CLIENTE.CODCEP, 2, .t., .t.),2) as SIGEST, ;
		val(str(iif( VENDAS.UFLOJA='S' .or. vendas.FlgTip=1, 0,;
			aIcms[1 + ascan(aIcms, padr(LeCidade(CLIENTE.CODCEP, 2, .t., .t.),2))]), 5, 2)) as ICMCLI;
   from VENDAS, CLIENTE, MOVTOS, PRODUTO ;
  where VENDAS.DATOPE between dInicio .and. dFinal .and. ;
		VENDAS.CODCLI = CLIENTE.CODCLI .and. ;
        MOVTOS.NUMDOC+dtos(MOVTOS.DATMOV) = VENDAS.NUMNOT + dtos(VENDAS.DATOPE) .and. ;
        PRODUTO.CODMAT = MOVTOS.CODMAT .and. ;
        (left(VENDAS.NUMNOT, 2) + '-') $ cSeries .and. ;
		iif(VENDAS.FLGEST = 'C', MOVTOS.TIPMOV = '7', .t.) .and. ;
        VENDAS.TIPNOT = '+' ;
  order by VENDAS.NUMNOT ;        
   into cursor _Total3

   && Pega somente as que forem somente de devolucao
select VENDAS.NUMNOT, VENDAS.UFLOJA, ;
		iif(VENDAS.FLGEST = 'C', 'S', 'N') as FLGEST, ;
		val(str((abs(VENDAS.VLRLIQ) - VENDAS.RETIDO - VENDAS.SUBSTT) * -100, 18, 2)) / 100 as VLRLIQ, ;
		val(str(abs(VENDAS.VLRNOT) * -100, 18, 2)) / 100 as VLRNOT, ;
		CLIENTE.CODCLI, ;
		VENDAS.RETIDO, ;
		iif(empty(PRODUTO.REFBAS), padr('pd' + alltrim(PRODUTO.CODMAT) + PRODUTO.DIGMAT, 12), PRODUTO.REFBAS) as REFBAS, ;
		VENDAS.SUBSTT, ;
		MOVTOS.CODMAT, ;
		MOVTOS.CODCOR, ;
		MOVTOS.CODTAM, ;
		MOVTOS.REDITE, ;
		MOVTOS.ICMITE, ;
		MOVTOS.IPIITE, ;
		MOVTOS.ICMTIP as TIPICM, ;
		MOVTOS.SERPRO as SERMAT, ;
		val(str(MOVTOS.QTDMOV * -100, 10, 2)) / 100 as QTDMOV, ;
		val(str(MOVTOS.VLRVEN * (abs(VENDAS.VLRLIQ) - VENDAS.RETIDO - VENDAS.SUBSTT) / abs(VENDAS.VLRNOT) * -100, 18, 2)) / 100 as VLRVEN, ;
		padr(LeCidade(CLIENTE.CODCEP, 2, .t., .t.),2) as SIGEST, ;
		val(str(iif( VENDAS.UFLOJA='S' .or. vendas.FlgTip=1, 0,;
			aIcms[1 + ascan(aIcms, padr(LeCidade(CLIENTE.CODCEP, 2, .t., .t.),2))]), 5, 2)) as ICMCLI;
   from VENDAS, CLIENTE, MOVTOS, PRODUTO ;
  where VENDAS.DATOPE between dInicio .and. dFinal .and. ;
		VENDAS.CODCLI = CLIENTE.CODCLI .and. ;
        MOVTOS.NUMDOC+dtos(MOVTOS.DATMOV) = VENDAS.NUMNOT + dtos(VENDAS.DATOPE) .and. ;
        PRODUTO.CODMAT = MOVTOS.CODMAT .and. ;
		iif(VENDAS.FLGEST = 'C', MOVTOS.TIPMOV = '7', .t.) .and. ;
        (left(VENDAS.NUMNOT, 2) + '-') $ cSeries .and. ;
        VENDAS.TIPNOT = '-' ;
  order by VENDAS.NUMNOT ;        
   into cursor _Total4
   
   && Essa estrutura sera o ponto de partida dos outros selects.
select * from _Total1 ;
 union (select * from _Total2) ;
 union (select * from _Total3) ;
 union (select * from _Total4) ;
  into cursor _Total

select _Total0
use
select _Total1
use
select _Total2
use
select _Total3
use
select _Total4
use

***
***          Somente estruturas de controle para compras
***---------------------------------------------------------------------------------------


***
***          Registros tipo 10 e 11 (Header do arquivo final)
***---------------------------------------------------------------------------------------
select '10' as Chave, cCGC + cInscricao + cRazao + cMunicipio + cEstado + cFAX + dtos(dInicio) + dtos(dFinal) + '131' as Linha ;
  from TABELAS ;
 where recno() = 1 ;
  into cursor _Tipo10
select '11' as Chave, cEndereco + cNumero + cComplemento + cBairro + cCEP + cContato + cTelefone as Linha ;
  from TABELAS ;
 where recno() = 1 ;
  into cursor _Tipo11

*** 
***          Registros tipo 50 Vendas (Registro de total de nota fiscal)
***---------------------------------------------------------------------------------------
wait 'Gerando estruturas dos registros tipo 50 (Vendas)...' window nowait
select '50' as Chave, ;
		iif(VENDAS.CONSFI, '00000000000000', left(CLIENTE.NUMDOC, 14)) + ;
		iif(VENDAS.CONSFI, 'ISENTO        ', left(CLIENTE.INSEST, 14)) + ;
		dtos(VENDAS.DATOPE) + ;
		padr(LeCidade(CLIENTE.CODCEP, 2, .t., .t.), 2) + ;
		cModelo + cSerie + cSubSerie + ;  
		strtran(right(_Total.NUMNOT, 6), ' ', '0') + ;
        left(VENDAS.NATFIS, 3) + ;
		strzero(abs(VENDAS.VLRLIQ) * 100, 13) + ;
	    strzero(sum(iif(_Total.TIPICM < 4 .or. _Total.TIPICM = 5, 00.000, ;
	      		RetImpItem(.t., ;
	      		           _Total.ICMITE, ;
		  	               _Total.REDITE, ;
	      		           _Total.TIPICM, ;
		  	               _Total.VLRVEN, ;
		  	               (abs(VENDAS.VLRLIQ) - VENDAS.RETIDO - VENDAS.SUBSTT) / abs(VENDAS.VLRNOT), ;
		  	               iif(VENDAS.CONSFI .or. PaImporta, 1, (_Total.IPIITE / 100) + 1)))) * 100, 13) + ;
	    strzero(sum(iif(_Total.TIPICM < 4 .or. _Total.TIPICM = 5, 00.000, ;
	      		RetImpItem(.f., ;
	      		           _Total.ICMITE, ;
		  	               _Total.REDITE, ;
	      		           _Total.TIPICM, ;
		  	               _Total.VLRVEN, ;
		  	               (abs(VENDAS.VLRLIQ) - VENDAS.RETIDO - VENDAS.SUBSTT) / abs(VENDAS.VLRNOT), ;
		  	               iif(VENDAS.CONSFI .or. PaImporta, 1, (_Total.IPIITE / 100) + 1)))) * 100, 13) + ;
		strzero(sum(iif(_Total.SERMAT <> 2 .or. _Total.TIPICM = 4, 00.000, _Total.VLRVEN)) * 100, 13) + ;
		strzero(sum(iif(_Total.SERMAT <> 2, _Total.VLRVEN, 00.000)) * 100, 13) + ;
		strzero(_Total.ICMITE * 100, 4) + ;
		iif(VENDAS.FLGEST = 'C', 'S', 'N') as Linha ;
   from _Total, CLIENTE, VENDAS, PRODUTO ;
  where VENDAS.NUMNOT = _Total.NUMNOT .and. ;
        PRODUTO.CODMAT = _Total.CODMAT .and. ;
		CLIENTE.CODCLI = _Total.CODCLI ;
  order by _Total.NUMNOT, _Total.ICMITE ;
  group by _Total.NUMNOT, _Total.ICMITE ;
   into cursor _Tipo50
aTotais[1] = _tally

*       && Usa esta estrutura somente pra testes, pra verificar se esta colunando e
*       && jogando os valores corretamente
*    copy to teste sdf
*    create dbf ('teste');
*          (tipo      c(02   ),;
*           cgc       c(14   ),;
*           inscri    c(14   ),;
*           emissao   d(08   ),;
*           UF        c(02   ),;
*           modelo    c(02   ),;
*           serie     c(03   ),;
*           subserie  c(02   ),;
*           numero    c(06   ),;
*           cfop      c(03   ),;
*           total     n(13   ),;
*           base      n(13   ),;
*           icms      n(13   ),;
*           isento    n(13   ),;
*           outros    n(13   ),;
*           aliquota  n(04   ),;
*           cancelado c(01   ))
*    append from teste.txt sdf


*** 
***          Registros tipo 50 Compras (Registro de total de nota fiscal)
***---------------------------------------------------------------------------------------
wait 'Gerando estruturas dos registros tipo 50 (Compras)...' window nowait

   && Primeiro gera uma estrutura com as notas, e os percentuais de ICMS e IPI 
   && existentes em cada nota, pois cada nota pode ter varios percentuais, e cada 
   && um deles deve ser uma nova linha.
select 'ICM' as TIPO, COMPRAS.NUMNOT, COMPRAS.CODFOR, COMPRAS.DATOPE, MOVTOS.ICMITE, 00.00 as IPIITE;
  from COMPRAS, MOVTOS ;
 where COMPRAS.DATOPE between dInicio .and. dFinal .and. ;
       MOVTOS.TIPMOV+dtos(MOVTOS.DATMOV)+MOVTOS.NUMDOC+MOVTOS.CODMAT+MOVTOS.CODFOR = '1'+dtos(COMPRAS.DATOPE)+COMPRAS.NUMNOT .and. ;
       COMPRAS.FLGEST <> 'D' .and. ;
       (left(COMPRAS.NUMNOT, 2) + '-') $ cCmpSeries ;
 group by COMPRAS.NUMNOT, COMPRAS.CODFOR, ICMITE ;
union all ;
select 'IPI' as TIPO, COMPRAS.NUMNOT, COMPRAS.CODFOR, COMPRAS.DATOPE, 00.00 as ICMITE, MOVTOS.IPIITE ;
  from COMPRAS, MOVTOS ;
 where COMPRAS.DATOPE between dInicio .and. dFinal .and. ;
       MOVTOS.TIPMOV+dtos(MOVTOS.DATMOV)+MOVTOS.NUMDOC+MOVTOS.CODMAT+MOVTOS.CODFOR = '1'+dtos(COMPRAS.DATOPE)+COMPRAS.NUMNOT .and. ;
       COMPRAS.FLGEST <> 'D' .and. ;
       (left(COMPRAS.NUMNOT, 2) + '-') $ cCmpSeries ;
 group by COMPRAS.NUMNOT, COMPRAS.CODFOR, IPIITE ;
  into cursor _Cmp

   && Variaveis utilizadas nos calculos de imposto de compra
store 0 to nBasIPI4F, nVlrIPI4F, nBasICM4F, nVlrICM4F, nBasSub4F, nVlrSub4F

select '50' as Chave, ;
		left(CADFOR.CGC_MF, 14) + ;
		left(CADFOR.INSCRI, 14) + ;
		dtos(COMPRAS.DATOPE) + ;
		padr(LeCidade(CADFOR.CODCEP, 2, .t., .t.),2) + ;
		cCmpModelo + ' ' + cCmpSerie + cCmpSubSerie + ;  
		strtran(right(COMPRAS.NUMNOT, 6), ' ', '0') + ;
        padr(strtran(strtran(strtran(COMPRAS.NATURE, '.', ''), '/', ''), '-', ''), 3) + ;
		strzero(COMPRAS.VLRLIQ * 100, 13) + ;
		strzero(ClcIPI4F('1'+dtos(COMPRAS.DATOPE)+COMPRAS.NUMNOT, COMPRAS.CODFOR, COMPRAS.DESCON, 1, _Cmp.ICMITE, 'BASICM') * 100, 13) + ;
        strzero(nVlrICM4F * 100, 13) + ;
        strzero((COMPRAS.VLRLIQ - nBasICM4F) * 100, 13) + ;
        strzero(0, 13) + ;
		strzero(_Cmp.ICMITE * 100, 4) + ;
		iif(COMPRAS.FLGEST = 'D', 'S', 'N') as Linha ;
   from CADFOR, COMPRAS, _Cmp ;
  where COMPRAS.CODFOR + COMPRAS.NUMNOT = _Cmp.CODFOR + _Cmp.NUMNOT .and. ;
        CADFOR.CODFOR = COMPRAS.CODFOR .and. ;
        _Cmp.TIPO = 'ICM' ;
  order by COMPRAS.NUMNOT, _Cmp.ICMITE ;
  group by COMPRAS.NUMNOT, _Cmp.ICMITE ;
   into cursor _Tipo50C
aTotais[1] = aTotais[1] + _tally

*       && Usa esta estrutura somente pra testes, pra verificar se esta colunando e
*       && jogando os valores corretamente
*    copy to teste sdf
*    create dbf ('teste');
*          (tipo      c(02   ),;
*           cgc       c(14   ),;
*           inscri    c(14   ),;
*           emissao   d(08   ),;
*           UF        c(02   ),;
*           modelo    c(02   ),;
*           serie     c(03   ),;
*           subserie  c(02   ),;
*           numero    c(06   ),;
*           cfop      c(03   ),;
*           total     n(13   ),;
*           base      n(13   ),;
*           icms      n(13   ),;
*           isento    n(13   ),;
*           outros    n(13   ),;
*           aliquota  n(04   ),;
*           cancelado c(01   ))
*    append from teste.txt sdf
*brow


select '51' as Chave, ;
		left(CADFOR.CGC_MF, 14) + ;
		left(CADFOR.INSCRI, 14) + ;
		dtos(COMPRAS.DATOPE) + ;
		padr(LeCidade(CADFOR.CODCEP, 2, .t., .t.),2) + ;
		cCmpSerie + cCmpSubSerie + ;  
		strtran(right(COMPRAS.NUMNOT, 6), ' ', '0') + ;
        padr(strtran(strtran(strtran(COMPRAS.NATURE, '.', ''), '/', ''), '-', ''), 3) + ;
		strzero(COMPRAS.VLRLIQ * 100, 13) + ;
		strzero(ClcIPI4F('1'+dtos(COMPRAS.DATOPE)+COMPRAS.NUMNOT, COMPRAS.CODFOR, COMPRAS.DESCON, 2, _Cmp.IPIITE, 'VLRIPI') * 100, 13) + ;
        strzero((COMPRAS.VLRLIQ - nBasIPI4F - nVlrIPI4F) * 100, 13) + ;
        strzero(0, 13) + ;
		space(20) + ;
		iif(COMPRAS.FLGEST = 'D', 'S', 'N') as Linha ;
   from CADFOR, COMPRAS, _Cmp ;
  where COMPRAS.CODFOR + COMPRAS.NUMNOT = _Cmp.CODFOR + _Cmp.NUMNOT .and. ;
        CADFOR.CODFOR = COMPRAS.CODFOR .and. ;
        _Cmp.TIPO = 'IPI' ;
  order by COMPRAS.NUMNOT, _Cmp.IPIITE ;
  group by COMPRAS.NUMNOT, _Cmp.IPIITE ;
   into cursor _Tipo51
aTotais[3] = _tally

*       && Usa esta estrutura somente pra testes, pra verificar se esta colunando e
*       && jogando os valores corretamente
*    copy to teste sdf
*    create dbf ('teste');
*          (tipo      c(02   ),;
*           cgc       c(14   ),;
*           inscri    c(14   ),;
*           emissao   d(08   ),;
*           UF        c(02   ),;
*           serie     c(03   ),;
*           subserie  c(02   ),;
*           numero    c(06   ),;
*           cfop      c(03   ),;
*          total     n(13   ),;
*           ipi       n(13   ),;
*           isento    n(13   ),;
*           outros    n(13   ),;
*           brancos   n(20   ),;
*           cancelado c(01   ))
*    append from teste.txt sdf
*brow


*** 
***          Registros tipo 54 Vendas (Registro de produto - classificacao fiscal)
***---------------------------------------------------------------------------------------
wait 'Gerando estruturas dos registros tipo 54 (Vendas)...' window nowait
nContador = 0
cChaveAnt = '&#&*#*#*^^*'
select '54' as Chave, ;
		iif(VENDAS.CONSFI, '00000000000000', left(CLIENTE.NUMDOC, 14)) + ;
		cModelo + cSerie + cSubSerie + ;  
		strtran(substr(_Total.NUMNOT, 3), ' ', '0') + ;
        left(VENDAS.NATFIS, 3) + ;
		'000' + ;
		padr(alltrim(_Total.REFBAS), 14) + ;
		strzero(_Total.QTDMOV * 1000, 13) + ;
		strzero(_Total.VLRVEN * 100, 12) + ;
		strzero(0, 12) + ;
		strzero(iif(_Total.TIPICM <> 3 .and. _Total.SERMAT = 2 .and. _Total.ICMITE > 0, _Total.VLRVEN * 100, 0), 12) + ;
		strzero(iif(_Total.TIPICM  = 3 .and. _Total.SERMAT = 2 .and. _Total.ICMITE > 0, _Total.VLRVEN * 100, 0), 12) + ;
		strzero(iif(_Total.IPIITE = 0, 0, _Total.VLRVEN - (_Total.VLRVEN / (1 + (_Total.IPIITE / 100)))), 12) + ;
		strzero(_Total.ICMITE * 100, 4) as Linha ;
   from _Total, CLIENTE, PRODUTO, VENDAS ;
  where VENDAS.NUMNOT = _Total.NUMNOT .and. ;
        CLIENTE.CODCLI = _Total.CODCLI .and. ;
        PRODUTO.CODMAT = _Total.CODMAT ;
  order by _Total.NUMNOT ;
   into dbf _Tipo54
replace all LINHA with left(LINHA, 30) + strzero(AtuContador(substr(LINHA, 22, 6)), 3) + substr(LINHA, 34)
aTotais[4] = _tally

*       && Usa esta estrutura somente pra testes, pra verificar se esta colunando e
*       && jogando os valores corretamente
*    copy to teste sdf
*    create dbf ('teste');
*          (tipo      c(02   ),;
*           cgc       c(14   ),;
*           emissao   d(08   ),;
*           UF        c(02   ),;
*           modelo    c(02   ),;
*           serie     c(03   ),;
*           subserie  c(02   ),;
*           numero    c(06   ),;
*           item      c(02   ),;
*           produto   n(10   ),;
*           sittri    n(03   ),;
*           medida    n(03   ),;
*           qtd       n(13   ),;
*           valor     n(13   ),;
*           proprio   n(13   ),;
*           basesub   n(13   ),;
*           aliquota  n(04   ),;
*           ipi       n(13   ))
*    append from teste.txt sdf


*** 
***          Registros tipo 54 Compras (Registro de produto - classificacao fiscal)
***---------------------------------------------------------------------------------------
wait 'Gerando estruturas dos registros tipo 54 (Compras)...' window nowait
cChaveAnt = '&#&*#*#*^^*'

select '54' as Chave, ;
		left(CADFOR.CGC_MF, 14) + ;
		cCmpModelo + ' ' + cCmpSerie + cCmpSubSerie + ;  
		strtran(substr(COMPRAS.NUMNOT, 3), ' ', '0') + ;
        padr(strtran(strtran(strtran(COMPRAS.NATURE, '.', ''), '/', ''), '-', ''), 3) + ;
		'000' + ;
		padr(alltrim(iif(empty(PRODUTO.REFBAS), padr('pd' + alltrim(PRODUTO.CODMAT) + PRODUTO.DIGMAT, 12), PRODUTO.REFBAS)), 14) + ;
		strzero(MOVTOS.QTDMOV * 1000, 13) + ;
		strzero(MOVTOS.VLRVEN * 100, 12) + ;
		strzero(0, 12) + ;
		strzero(iif(MOVTOS->ICMTIP <> 3 .and. PRODUTO.SERMAT = 2 .and. MOVTOS.ICMITE > 0, MOVTOS.VLRVEN * 100, 0), 12) + ;
		strzero(iif(MOVTOS->ICMTIP  = 3 .and. PRODUTO.SERMAT = 2 .and. MOVTOS.ICMITE > 0, MOVTOS.VLRVEN * 100, 0), 12) + ;
		strzero(iif(MOVTOS->IPIITE = 0, 0, MOVTOS.VLRVEN - (MOVTOS.VLRVEN / (1 + (MOVTOS->IPIITE / 100)))), 12) + ;
		strzero(MOVTOS.ICMITE * 100, 4) as Linha ;
   from COMPRAS, CADFOR, MOVTOS, PRODUTO ;
 where COMPRAS.DATOPE between dInicio .and. dFinal .and. ;
       MOVTOS.TIPMOV+dtos(MOVTOS.DATMOV)+MOVTOS.NUMDOC+MOVTOS.CODMAT+MOVTOS.CODFOR = '1'+dtos(COMPRAS.DATOPE)+COMPRAS.NUMNOT .and. ;
       CADFOR.CODFOR = COMPRAS.CODFOR .and. ;
       PRODUTO.CODMAT = MOVTOS.CODMAT .and. ;
       COMPRAS.FLGEST <> 'D' .and. ;
       (left(COMPRAS.NUMNOT, 2) + '-') $ cCmpSeries ;
  order by COMPRAS.NUMNOT, COMPRAS.CODFOR ;
   into dbf _Tipo54C
replace all LINHA with left(LINHA, 30) + strzero(AtuContador(substr(LINHA, 22, 6)), 3) + substr(LINHA, 34)
aTotais[4] = aTotais[4] + _tally

*       && Usa esta estrutura somente pra testes, pra verificar se esta colunando e
*       && jogando os valores corretamente
*    copy to teste sdf
*    create dbf ('teste');
*          (tipo      c(02   ),;
*           cgc       c(14   ),;
*           emissao   d(08   ),;
*           UF        c(02   ),;
*           modelo    c(02   ),;
*           serie     c(03   ),;
*           subserie  c(02   ),;
*           numero    c(06   ),;
*           item      c(02   ),;
*           produto   n(10   ),;
*           sittri    n(03   ),;
*           medida    n(03   ),;
*           qtd       n(13   ),;
*           valor     n(13   ),;
*           proprio   n(13   ),;
*           basesub   n(13   ),;
*           aliquota  n(04   ),;
*           ipi       n(13   ))
*    append from teste.txt sdf


*** 
***          Registros tipo 60 Vendas (Registro de Cupom Fiscal - ECF)
***---------------------------------------------------------------------------------------
*!*	wait 'Gerando estruturas dos registros tipo 60 (Vendas)...' window nowait

*!*	select '60' as Chave, ;
*!*			space(28) + ;
*!*			dtos(VENDAS.DATOPE) + ;
*!*			VENDAS.NUMPDV + ;
*!*			'2D' + ;
*!*			min(VENDAS.CUPFIS) + ;
*!*			max(VENDAS.CUPFIS) + ;
*!*			strzero(sum(MOVTOS.VLRVEN) * 100, 14) + ;
*!*			strzero(sum(MOVTOS.VLRVEN * MOVTOS.ICMITE), 13) + ;
*!*			space(44) as Linha ;
*!*	   from VENDAS, MOVTOS ;
*!*	  where VENDAS.DATOPE between dInicio .and. dFinal .and. ;
*!*	        MOVTOS.NUMDOC+dtos(MOVTOS.DATMOV) = VENDAS.NUMNOT + dtos(VENDAS.DATOPE) .and. ;
*!*	        !empty(VENDAS.CUPFIS) .and. ;
*!*	        MOVTOS.QTDMOV > 0 .and. ;
*!*	        VENDAS.NUMNOT = 'CF'  ;
*!*	  order by DATOPE ;
*!*	  group by DATOPE ;
*!*	   into cursor _Tipo60
*!*	   
*!*	aTotais[6] = _tally
aTotais[6] = 0

*       && Usa esta estrutura somente pra testes, pra verificar se esta colunando e
*       && jogando os valores corretamente
*    copy to teste sdf
*    create dbf ('teste');
*          (tipo      c(02   ),;
*           brancos   c(28   ),;
*           emissao   d(08   ),;
*           pdv       c(03   ),;
*           modelo    c(02   ),;
*           inicial   n(06   ),;
*           final     n(06   ),;
*           diario    n(14   ),;
*           icms      n(13   ),;
*           brancos2  c(44   ))
*    append from teste.txt sdf

*** 
***          Registros tipo 75 Vendas (Registro de codigo de produto e servico)
***---------------------------------------------------------------------------------------
wait 'Gerando estruturas dos registros tipo 75 (Vendas)...' window nowait

select '75' as Chave, ;
		dtos(dInicio) + dtos(dFinal) + ;
		padr(alltrim(_Total.REFBAS), 14) + ;
		space(08) + ;
		padr(alltrim(PRODUTO.DESMAT) + ' - ' + alltrim(PRODUTO.ESPMAT), 53) + ;
		padr(PRODUTO.UNIDAD, 6) + ;
		'0' + ;
           iif(_Total.TIPICM  = 3 .and. _Total.SERMAT = 2 .and. _Total.ICMITE > 0, ;
               iif(_Total.REDITE > 0, '7', '1'), ;
           iif(_Total.TIPICM < 3 .or. _Total.TIPICM = 5, '4', ;
           iif(_Total.REDITE > 0, '2', '0'))) + ;
		+ '0' + ;
		strzero(_Total.IPIITE * 100, 4) + ;
		strzero(PRODUTO.PERICM * 100, 4) + ;
		strzero(_Total.REDITE * 100, 4) + ;
		strzero(sum(iif(_Total.TIPICM  = 3 .and. _Total.SERMAT = 2 .and. _Total.ICMITE > 0, _Total.VLRVEN * 100, 0)), 12) as Linha, ;
        iif(_Total.TIPICM  = 3 .and. _Total.SERMAT = 2 .and. _Total.ICMITE > 0, ;
               iif(_Total.REDITE > 0, '7', '1'), ;
           iif(_Total.TIPICM < 3 .or. _Total.TIPICM = 5, '4', ;
           iif(_Total.REDITE > 0, '2', '0'))) as Indice, ;
        _Total.CODMAT + str(_Total.TIPICM, 1) + str(PRODUTO.PERICM,5,2) + str(_Total.SERMAT, 1) + str(_Total.REDITE,5,2) as Unico ;
   from _Total, PRODUTO, VENDAS ;
  where VENDAS.NUMNOT = _Total.NUMNOT .and. ;
        PRODUTO.CODMAT = _Total.CODMAT ;
  group by _Total.CODMAT;
  order by _Total.CODMAT;
   into cursor _Tipo75
aTotais[10] = _tally


*** 
***          Registros tipo 75 Compras (Registro de codigo de produto e servico)
***---------------------------------------------------------------------------------------
wait 'Gerando estruturas dos registros tipo 75 (Compras)...' window nowait
select '75' as Chave, ;
		dtos(dInicio) + dtos(dFinal) + ;
		padr(alltrim(iif(empty(PRODUTO.REFBAS), padr('pd' + alltrim(PRODUTO.CODMAT) + PRODUTO.DIGMAT, 12), PRODUTO.REFBAS)), 14) + ;
		space(08) + ;
		padr(alltrim(PRODUTO.DESMAT) + ' - ' + alltrim(PRODUTO.ESPMAT), 53) + ;
		padr(PRODUTO.UNIDAD, 6) + ;
		'0' + ;
           iif(PRODUTO.TIPICM  = 3 .and. PRODUTO.SERMAT = 2 .and. MOVTOS.ICMITE > 0, ;
               iif(MOVTOS.REDITE > 0, '7', '1'), ;
           iif(PRODUTO.TIPICM < 3 .or. PRODUTO.TIPICM = 5, '4', ;
           iif(MOVTOS.REDITE > 0, '2', '0'))) + ;
		+ '0' + ;
		strzero(MOVTOS.IPIITE * 100, 4) + ;
		strzero(PRODUTO.PERICM * 100, 4) + ;
		strzero(MOVTOS.REDITE * 100, 4) + ;
		strzero(0, 12) as Linha, ;
        iif(PRODUTO.TIPICM  = 3 .and. PRODUTO.SERMAT = 2 .and. MOVTOS.ICMITE > 0, ;
               iif(MOVTOS.REDITE > 0, '7', '1'), ;
           iif(PRODUTO.TIPICM < 3 .or. PRODUTO.TIPICM = 5, '4', ;
           iif(MOVTOS.REDITE > 0, '2', '0'))) as Indice, ;
        PRODUTO.CODMAT + str(PRODUTO.TIPICM, 1) + str(PRODUTO.PERICM,5,2) + str(PRODUTO.SERMAT, 1) + str(MOVTOS.REDITE,5,2) as Unico ;
   from _Cmp, MOVTOS, PRODUTO ;
  where MOVTOS.TIPMOV+dtos(MOVTOS.DATMOV)+MOVTOS.NUMDOC+MOVTOS.CODMAT+MOVTOS.CODFOR = '1'+dtos(_Cmp.DATOPE)+_Cmp.NUMNOT .and. ;
        PRODUTO.CODMAT = MOVTOS.CODMAT .and. ;
        MOVTOS.CODFOR = _Cmp.CODFOR .and. ;
        MOVTOS.TIPMOV = '1' ;
  group by MOVTOS.CODMAT;
  order by MOVTOS.CODMAT;
   into cursor _Tipo75C

aTotais[10] = _tally
select Chave, Linha from _Tipo75C where Unico not in (select Unico from _Tipo75) into cursor _QtdRegitros75
aTotais[10] = aTotais[10]+ _tally
use in _QtdRegitros75

*** 
***          Registros tipo 90 (Registro de totalizacao do arquivo)
***---------------------------------------------------------------------------------------
wait 'Gerando estruturas dos registros tipo 90...' window nowait
select '90' as Chave, cCGC + cInscricao + ;
	   padr(iif(aTotais[ 1] > 0, '50' + strzero(aTotais[ 1], 8), '') + ;
			iif(aTotais[ 3] > 0, '51' + strzero(aTotais[ 3], 8), '') + ;
			iif(aTotais[ 4] > 0, '54' + strzero(aTotais[ 4], 8), '') + ;
			iif(aTotais[ 6] > 0, '60' + strzero(aTotais[ 6], 8), '') + ;
			iif(aTotais[10] > 0, '75' + strzero(aTotais[10], 8), '') + ;
			'99' + strzero(1 + 1 + aTotais[1] + aTotais[3] + aTotais[4] + aTotais[6] + aTotais[10] + 1, 8), 95) + '1' as Linha ;
   from TABELAS ;
  where recno() = 1 ;
   into cursor _Tipo90


***
***          Controles finais para gerar o arquivo para a exportacao
***---------------------------------------------------------------------------------------
select Chave, Linha from _Tipo10 ;
 union all (select Chave, Linha from _Tipo11) ;
 union all (select Chave, Linha from _Tipo50) ;
 union all (select Chave, Linha from _Tipo50C) ;
 union all (select Chave, Linha from _Tipo51) ;
  into cursor _Todos1 
select Chave, Linha from _Tipo54 ;
 union all (select Chave, Linha from _Tipo54C) ;
 union all (select Chave, Linha from _Tipo75) ;
 union all (select Chave, Linha from _Tipo75C where Unico not in (select Unico from _Tipo75)) ;
 union all (select Chave, Linha from _Tipo90) ;
  into cursor _Todos2
select * from _Todos1 union all (select * from _Todos2) into cursor _Todos

*!*	 union all (select Chave, Linha from _Tipo60) ;  

	&& Gera o arquivo texto
wait 'Gerando arquivo final da exportao fiscal...' window nowait
erase (cSaida)
copy to (cSaida) fields Chave, Linha SDF
use 
select _Todos1
use
select _Todos2
use
select _Cmp
use
select _Total
use 
select _Tipo10
use 
select _Tipo11
use 
select _Tipo50
use 
select _Tipo50C
use 
select _Tipo51
use 
select _Tipo54
use 
*!*	select _Tipo60
*!*	use 
select _Tipo75
use 
select _Tipo75C
use 
select _Tipo90
use
wait clear
=Erros('-Arquivo gerado:' + cSaida)
